- [x] User pyop <https://github.com/IdentityPython/pyop> or authlib
- [x] Test against pyoidc https://pyoidc.readthedocs.io/en/stable
- [ ] Test against oidc-client
- [x] Test against Flask-OIDC
- [ ] Test against authlib
- [ ] Test against django allauth

## Test scenarios

- Flows
  - [x] Auth code
  - [ ] Implicit
  - [ ] Hybrid
- [x] Auth success, claims and userinfo included
- [x] Auth denied by user
- [ ] Refresh token usage...
- [ ] Auth code prompt selection
- [ ] Nonce reuse
- [ ] PKCE

## Integrations

- [x] Flask
- [ ] Django
- [ ] Starlett

## Spec implementation

1. Client Auth

- [ ] 3.1. Authentication using the Authorization Code Flow
  - [ ] 3.1.1. Authorization Code Flow Steps
  - [ ] 3.1.2. Authorization Endpoint
    - [ ] 3.1.2.1. Authentication Request
    - [ ] 3.1.2.2. Authentication Request Validation
    - [ ] 3.1.2.3. Authorization Server Authenticates End-User
    - [ ] 3.1.2.4. Authorization Server Obtains End-User Consent/Authorization
    - [ ] 3.1.2.5. Successful Authentication Response
    - [ ] 3.1.2.6. Authentication Error Response
    - [ ] 3.1.2.7. Authentication Response Validation
  - [ ] 3.1.3. Token Endpoint
    - [ ] 3.1.3.1. Token Request
    - [ ] 3.1.3.2. Token Request Validation
    - [ ] 3.1.3.3. Successful Token Response
    - [ ] 3.1.3.4. Token Error Response
    - [ ] 3.1.3.5. Token Response Validation
    - [ ] 3.1.3.6. ID Token
    - [ ] 3.1.3.7. ID Token Validation
    - [ ] 3.1.3.8. Access Token Validation
- [ ] 3.2. Authentication using the Implicit Flow
- [ ] 3.3. Authentication using the Hybrid Flow
- [ ] 9.  Client Authentication
- [ ] 12. Using Refresh Tokens
  - [ ] 12.1. Refresh Request
  - [ ] 12.2. Successful Refresh Response
  - [ ] 12.3. Refresh Error Response
